%load data
load upRun1.log;
%upRun1 = horizRun1;
time = upRun1(:,1);
angle = upRun1(:,2);
vel = upRun1(:,3);
torque = upRun1(:,4);
angle = angle*pi/500;

%model constants
Cg = 0.72004226501331;
Cc = 0.12329504549906;
Cv = 0.01339875306335;
I = 0.01944485646583;

%initial state
x = [0; 0];
tTotal = size(time);
tTotal = tTotal(1);
xVect = zeros(tTotal,2);

%measurement matrix;
H = [1 0;
     0 1];

%process noise
Q = [1 0;
     0 1];
 
%measurement noise
R = [0.1 0;
     0 5];

%initial noise covariance
P = [1 0;
     0 1];

tprev = 0.0;
for i=2:size(time)
    xVect(i,:) = x;
    dt = time(i) - tprev;
    z = [angle(i); (angle(i)-angle(i-1))/dt];
    OF = [1 dt;
          -Cg*cos(angle(i))*dt/I 1-Cv*dt/I];
    %OF = eye(2);
    
    %propogate state
    x(1) = x(1) + dt*x(2);
    x(2) = x(2) + dt*(torque(i)-Cg*sin(x(1))-Cc*sign(x(2))-Cv*x(2))/I;
    torque(i)
    dt
    dt*(torque(i)-Cg*sin(x(1))-Cc*sign(x(2))-Cv*x(2))/I
    %accel(i) = dt*(torque(i)-Cg*sin(x(1))-Cc*sign(x(2))-Cv*x(2))/I;
    
    %determine new noise covariance
    P = OF*P*OF' + Q
    
    %calculate kalman gain
    K = P*H'*inv(H*P*H'+R)
    
    x
    %calculate new x estimate
    x = x + K*(z-H*x)
    
    %and new noise estimate
    P = (eye(2)-K*H)*P
        
    tprev = time(i);
end

plot(xVect(:,1));
figure
plot(xVect(:,2));