/************************************************************************/
/*
Example of linearizing dynamics.
*/
/************************************************************************/

#include <stdio.h>
#include <math.h>
#include "dynamics.h"

/************************************************************************/
/************************************************************************/
/************************************************************************/
/************************************************************************/
/************************************************************************/
/************************************************************************/
/************************************************************************/
/************************************************************************/
/* main */

int main(int argc, char **argv)
{
  int i, j;
  float state[N_STATE_DIMENSIONS];
  float next_state_0[N_STATE_DIMENSIONS];
  float next_state_1[N_STATE_DIMENSIONS];
  float action[N_ACTION_DIMENSIONS];
  float delta = 1e-2; // often need to play with this value to see where
                      // you get a linearization that is insensitive to it.
  float a[N_STATE_DIMENSIONS][N_STATE_DIMENSIONS];
  float b[N_STATE_DIMENSIONS][N_ACTION_DIMENSIONS];
	
  for( i = 0; i < N_STATE_DIMENSIONS; i++ )
    state[i] = the_desired_state[i];
  for( i = 0; i < N_ACTION_DIMENSIONS; i++ )
    action[i] = 0;
  
  init_dynamics();
  set_state( 0.0, state );
  integrate_one_step( action, next_state_0 );

  for( i = 0; i < N_STATE_DIMENSIONS; i++ )
    {
      state[i] += delta;
      set_state( 0.0, state );
      integrate_one_step( action, next_state_1 );
      for( j = 0; j < N_STATE_DIMENSIONS; j++ )
	{
	  a[j][i] = (next_state_1[j] - next_state_0[j])/delta;
	}
      state[i] -= delta;
    }

  for( i = 0; i < N_ACTION_DIMENSIONS; i++ )
    {
      action[i] += delta;
      set_state( 0.0, state );
      integrate_one_step( action, next_state_1 );
      for( j = 0; j < N_STATE_DIMENSIONS; j++ )
	{
	  b[j][i] = (next_state_1[j] - next_state_0[j])/delta;
	}
      action[i] -= delta;
    }

  printf( "A:\n" );
  for( i = 0; i < N_STATE_DIMENSIONS; i++ )
    {
      for( j = 0; j < N_STATE_DIMENSIONS; j++ )
	{
	  printf( "%g ", a[i][j] );
	}
      printf( "\n" );
    }

  printf( "B:\n" );
  for( i = 0; i < N_STATE_DIMENSIONS; i++ )
    {
      for( j = 0; j < N_ACTION_DIMENSIONS; j++ )
	{
	  printf( "%g ", b[i][j] );
	}
      printf( "\n" );
    }

  return 0;
}

/************************************************************************/

