/***********************************************************************
Mimic ODE simulation for the one link pendulum
Use u_array as policy.

***********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "useful.h"
#include "dynamics.h"
#include "dp.h"


/**********************************************************************/
/************************************************************************/
/* Globals */

// I am using 1D arrays for speed and simplicity
float v1[N_TOTAL_STATES];
/* the current policy */
float u_array[N_TOTAL_STATES][N_ACTION_DIMENSIONS];

/* pointers for swapping value functions */
float *v_k;

float *model_next_states = NULL; /* Need this to make compiler happy. */

/**********************************************************************/
/**********************************************************************/
/************************************************************************/
/* initialization */

int init()
{
  v_k = &(v1[0]);
		
  read_array_from_file( "v_k", v_k, N_TOTAL_STATES );
  read_array_from_file( "u_array", &(u_array[0][0]),
			N_TOTAL_STATES*N_ACTION_DIMENSIONS );
  init_dynamics();
  init_dp();

  return TRUE;
}

/**********************************************************************/
/*
main()
{
  int i, j;
  float score = 0;
  FILE *stream;
  float action[N_ACTION_DIMENSIONS];
  float initial_state[N_STATE_DIMENSIONS];
  float value;

  init();

  stream = fopen( "traj", "w" );
  if ( stream == NULL )
    {
      fprintf( stderr, "Can't open data file.\n" );
      exit( -1 );
    }


  initial_state[0] = 0.0;
  initial_state[1] = 0;
  set_state( 0.0, initial_state );

  for( i = 0; ; i++ )
    {
      if ( !lqr_covers_it( NULL, the_state, &value, action, NULL ) )
	lookup_action( the_state, u_array, v_k, action );

      fprintf( stream, "%g %g %g %g %g\n", the_time, the_state[0], 
	       the_state[1], action[0], score );

      printf( "%3d %6.2f %6.2f %6.2f %6.2f %6.2f\n", i, 
	       the_time, the_state[0], 
	       the_state[1], action[0], score );

      score += one_step_cost( the_state, action );
      integrate_one_step( action, NULL );

      if ( the_time > 9.99999 )
	{
	  fclose( stream );
	  exit( 0 );
	}
    }
}
*/
/**********************************************************************/
